#Copyright ReportLab Europe Ltd. 2000-2012
#see license.txt for license details
import os, sys, glob, ConfigParser, shutil
platform = sys.platform
pjoin = os.path.join
abspath = os.path.abspath
isfile = os.path.isfile
isdir = os.path.isdir
dirname = os.path.dirname
basename = os.path.basename
if __name__=='__main__':
    pkgDir=dirname(sys.argv[0])
else:
    pkgDir=dirname(__file__)
if not pkgDir:
    pkgDir=os.getcwd()
elif not os.path.isabs(pkgDir):
    pkgDir=os.path.abspath(pkgDir)

daily = int(os.environ.get('RL_EXE_DAILY','0'))
exeBuild = int(os.environ.get('RL_EXE_BUILD','0'))

import distutils
from distutils.core import setup, Extension
from distutils import sysconfig
#from distutils.dist import Distribution
#import py_compile
#class ImpureDist(Distribution):
#   def __init__(self,attrs):
#       Distribution.__init__(self,attrs)
#       print '############################ ImpureDist initialized'
#   def has_ext_modules(self):
#       return True

# from Zope - App.Common.package_home
def package_home(globals_dict):
    __name__=globals_dict['__name__']
    m=sys.modules[__name__]
    r=os.path.split(m.__path__[0])[0]
    return r

def get_version():
    if daily: return 'daily'
    #determine Version

    #first try source
    FN = pjoin(pkgDir,'src','rlextra','__init__')
    try:
        for l in open(pjoin(FN+'.py'),'r').readlines():
            if l.startswith('Version'):
                exec l.strip()
                return Version
    except:
        pass

    #don't have source, try import
    import imp
    for desc in ('.pyc', 'rb', 2), ('.pyo', 'rb', 2):
        try:
            fn = FN+desc[0]
            f = open(fn,desc[1])
            m = imp.load_module('rlextra',f,fn,desc)
            return m.Version
        except:
            pass
    raise ValueError('Cannot determine RLExtra Version')

class config:
    def __init__(self):
        try:
            self.parser = ConfigParser.RawConfigParser()
            self.parser.read(pjoin(pkgDir,'setup.cfg'))
        except:
            self.parser = None

    def __call__(self,sect,name,default=None):
        try:
            return self.parser.get(sect,name)
        except:
            return default
config = config()

#this code from /FBot's PIL setup.py
def aDir(P, d, x=None):
    if d and os.path.isdir(d) and d not in P:
        if x is None:
            P.append(d)
        else:
            P.insert(x, d)

def pfxJoin(pfx,*N):
    R=[]
    for n in N:
        R.append(os.path.join(pfx,n))
    return R

INFOLINES=[]
def infoline(t):
    print t
    INFOLINES.append(t)

try:
    set
except:
    class set(list):
        def add(self,e):
            if e not in self:
                self.append(e)

def expandFiles(baseDir,F):
    R = set([])
    for f in F:
        f = f.replace('/',os.sep)
        if '*' in f or '?' in f:
            pat = pjoin(baseDir,f)
            x = len(pat)-len(f)
            for fm in glob.glob(pat):
                R.add(fm[x:])
        else:
            R.add(f)
    return list(R)

RLXDIR=pjoin(pkgDir,'src','rlextra')
rlextra_files= expandFiles(RLXDIR,
        ([]
        +[pjoin('rml2pdf',x) for x in '''00README.txt dynamic_rml.dtd rml.dtd'''.split()]
        +[pjoin('pageCatcher',x) for x in '''00README.txt replogo.bmp testfile.pdf'''.split()]
        +[pjoin('security',x) for x in ['*.txt'] 
        +[pjoin('doc',y) for y in '''*.gif *.rml'''.split()]]
        +[pjoin('graphics','guiedit','sample.csv')]
        ))
PYC=[pjoin('src','rlextra',x) for x in (
    pjoin('rml2pdf','rml2pdf.py'),
    pjoin('pageCatcher','pageCatcher.py'),
    pjoin('utils','zipapp.py'),
    pjoin('utils','ubold.py'),
    pjoin('graphics','guiedit','datacharts.py'),
    )]

if not exeBuild:
    scriptsPath=pjoin(pkgDir,'build','scripts')
    def makeScript(pkgName,modName,scriptName=None):
        try:
            bat=sys.platform in ('win32','amd64')
            if scriptName is None:
                scriptName = modName
            scriptPath=os.path.join(scriptsPath,scriptName+(bat and '.bat' or ''))
            exePath=sys.executable
            f = open(scriptPath,'w')
            try:
                if bat:
                    text = '@echo off\n"%s" -m "%s.%s" %%*\n' % (exePath,pkgName,modName)
                else:
                    text = '#!/bin/sh\nexec "%s" -m "%s.%s" $*\n' % (exePath,pkgName,modName)
                f.write(text)
            finally:
                f.close()
        except:
            print 'script for %s.%s not created or erroneous' % (pkgName, modName)
            import traceback
            traceback.print_exc(file=sys.stdout)
            return None
        print 'Created "%s"' % scriptPath
        return scriptPath
else:
    postInstall='''
import sys,os,shutil,webbrowser,traceback

from rlextra.graphics import guiedit  

DOCUMENTATION_LINK = """
[InternetShortcut]
URL=https://www.reportlab.com/software/documentation/
"""


NAME = 'Diagra for Python %s.lnk' % sys.version[:3]

def makeBat(pkgName,modName):
    try:
        exec 'import %s as pkg' % pkgName
        pkgPath = pkg.__path__[0]
        scriptsPath=os.path.dirname(sys.argv[0])
        exePath=os.path.join(os.path.dirname(scriptsPath),'python.exe')
        for ext in ('.py','.pyc','.pyo'):
            modPath = os.path.join(pkgPath,modName+ext)
            if os.path.isfile(modPath):
                batPath = os.path.join(scriptsPath,modName+'.bat')
                f = open(batPath,'w')
                f.write('@echo off\\n"%s" "%s" %%*\\n' % (exePath,modPath))
                f.close()
                file_created(batPath)
                print 'Created "%s"' % batPath
                return
    except:
        print 'batch script for %s.%s not created or erroneous' % (pkgName, modName)
        traceback.print_exc()
if sys.argv[1]=='-install':
    makeBat('rlextra.rml2pdf','rml2pdf')
    makeBat('rlextra.pageCatcher','pageCatcher')
    makeBat('rlextra.pageCatcher','pdfexplorer')
    makeBat('rlextra.utils','zipapp')

    for i,smn in enumerate(("CSIDL_COMMON_STARTMENU","CSIDL_STARTMENU")):
        try:
            START_MENU = get_special_folder_path(smn)
            reportlab_start_menu = os.path.join(START_MENU, 'Programs', 'ReportLab')
            DOCUMENTATION_FILE = os.path.join(reportlab_start_menu, 'Documentation.url')
            reportlab_start_menu = os.path.join(START_MENU, 'Programs', 'ReportLab')
            if not os.path.exists(reportlab_start_menu):
                os.makedirs(reportlab_start_menu)
                directory_created(reportlab_start_menu)

            _file = open(DOCUMENTATION_FILE, 'w')
            _file.write(DOCUMENTATION_LINK)
            _file.close()
            file_created(DOCUMENTATION_FILE)

            create_shortcut(
                    os.path.join(sys.prefix, 'pythonw.exe'), # program
                'Description of the shortcut', # description
                NAME, # filename
                os.path.join(os.path.dirname(guiedit.__file__), 'guiedit.pyc'), # parameters
                '', # workdir
                os.path.join(os.path.dirname(guiedit.__file__), 'favicon.ico'),
                )
            # move shortcut from current directory to reportlab_start_menu
            shutil.move(os.path.join(os.getcwd(), NAME),
                        os.path.join(reportlab_start_menu, NAME))
            file_created(os.path.join(reportlab_start_menu, NAME))
            break
        except:
            if i:
                print 'Start menu entry creation failed'
                traceback.print_exc()
'''

def main():
    #test to see if we've a special command
    if 'tests' in sys.argv or 'tests-preinstall' in sys.argv:
        if len(sys.argv)!=2:
            raise ValueError('tests commands may only be used alone')
        cmd = sys.argv[-1]
        PYTHONPATH=[pkgDir]
        if cmd=='tests-preinstall':
            PYTHONPATH.insert(0,pjoin(pkgDir,'src'))
        os.environ['PYTHONPATH']=os.pathsep.join(PYTHONPATH)
        os.chdir(RLXDIR)
        os.system("%s testall.py" % sys.executable)
        return
    cwd = os.getcwd()

    if exeBuild:
        f=open('_rlxpinst.py','w')
        f.write(postInstall)
        f.close()
        scripts=['_rlxpinst.py']
        options = {"bdist_wininst": {"install_script": "_rlxpinst.py"}}
    else:
        scripts = []
        options = {}
        if sys.version_info[:2]>=(2,5):
            if not isdir(scriptsPath): os.makedirs(scriptsPath)
            scripts.extend(filter(None,[
                    makeScript('rlextra.rml2pdf','rml2pdf'),
                    makeScript('rlextra.pageCatcher','pageCatcher'),
                    makeScript('rlextra.pageCatcher','pdfexplorer'),
                    makeScript('rlextra.utils','zipapp'),
                    makeScript('rlextra.graphics.guiedit','guiedit','diagra'),
                    ]))

    SPECIAL_PACKAGE_DATA = {}
    LIBS = []
    LIBRARIES=[]
    EXT_MODULES = []
    srcDir = dirname(RLXDIR)
    #copy some special case files into place so package_data will treat them properly
    PACKAGE_DIR = {'rlextra': RLXDIR}
    for fn,dst in SPECIAL_PACKAGE_DATA.iteritems():
        shutil.copyfile(fn,pjoin(PACKAGE_DIR['rlextra'],dst))
        rlextra_files.append(dst)

    for pyc in PYC:
        n = len(os.path.split(pyc)) #we'll drop the rlextra
        pat = os.path.splitext(pjoin(pkgDir,pyc))[0]+('_[23][0123456789].py[co]')
        F = glob.glob(pat)
        if not F:
            print '!!!!! no compiled files match pattern %r' % pat
        rlextra_files.extend([f for f in F])

    try:
        setup(
            name="rlextra",
            version=get_version(),
            license="BSD license (see license.txt for details), Copyright (c) 2000-2013, ReportLab Inc.",
            description="The Reportlab Extra Toolkit",
            long_description="""The ReportLab Extra Toolkit. Python library for generating PDFs and graphics.""",

            author="Robinson, Watters, Lee, Precedo, Becker and many more...",
            author_email="info@reportlab.com",
            url="http://www.reportlab.com/",
            packages=[
                    'rlextra',
                    'rlextra.pageCatcher',
                    'rlextra.rml2pdf',
                    'rlextra.security',
                    'rlextra.radxml',
                    'rlextra.utils',
                    'rlextra.graphics',
                    'rlextra.graphics.guiedit',
                    'rlextra.thirdparty',
                    'rlextra.thirdparty.xlrd',
                    'rlextra.thirdparty.pyPdf',
                    ],
            package_dir = PACKAGE_DIR,
            package_data = {'rlextra': rlextra_files},
            libraries = LIBRARIES,
            ext_modules =   EXT_MODULES,
            scripts = scripts,
            options = options,
            )
        print
        print '########## SUMMARY INFO #########'
        print '\n'.join(INFOLINES)
    finally:
        for dst in SPECIAL_PACKAGE_DATA.itervalues():
            os.remove(pjoin(PACKAGE_DIR['reportlab'],dst))
            reportlab_files.remove(dst)

if __name__=='__main__':
    main()
